"""
    Cakemail API

    The Cakemail API exposes multiple APIs including Authentication, Marketing, Contact, Transactional, Analytic, Content, Account and Partner.  # noqa: E501

    The version of the OpenAPI document: 1.9.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from cakemail_openapi.api_client import ApiClient, Endpoint as _Endpoint
from cakemail_openapi.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from cakemail_openapi.model.action import Action
from cakemail_openapi.model.actions_response import ActionsResponse
from cakemail_openapi.model.create_action_response import CreateActionResponse
from cakemail_openapi.model.delete_action_response import DeleteActionResponse
from cakemail_openapi.model.get_action_response import GetActionResponse
from cakemail_openapi.model.http_bad_request_error import HTTPBadRequestError
from cakemail_openapi.model.http_validation_error import HTTPValidationError
from cakemail_openapi.model.links_response import LinksResponse
from cakemail_openapi.model.patch_action import PatchAction
from cakemail_openapi.model.patch_action_response import PatchActionResponse
from cakemail_openapi.model.send_test_action import SendTestAction
from cakemail_openapi.model.send_test_action_response import SendTestActionResponse


class ActionApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_action_endpoint = _Endpoint(
            settings={
                'response_type': (CreateActionResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/workflows/{workflow_id}/actions',
                'operation_id': 'create_action',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_id',
                    'action',
                    'account_id',
                    'lock_key',
                ],
                'required': [
                    'workflow_id',
                    'action',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'lock_key',
                ]
            },
            root_map={
                'validations': {
                    ('lock_key',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]{8,}$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_id':
                        (str,),
                    'action':
                        (Action,),
                    'account_id':
                        (int,),
                    'lock_key':
                        (str,),
                },
                'attribute_map': {
                    'workflow_id': 'workflow_id',
                    'account_id': 'account_id',
                    'lock_key': 'lock_key',
                },
                'location_map': {
                    'workflow_id': 'path',
                    'action': 'body',
                    'account_id': 'query',
                    'lock_key': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.delete_action_endpoint = _Endpoint(
            settings={
                'response_type': (DeleteActionResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/workflows/{workflow_id}/actions/{action_id}',
                'operation_id': 'delete_action',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'action_id',
                    'workflow_id',
                    'account_id',
                    'lock_key',
                ],
                'required': [
                    'action_id',
                    'workflow_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'lock_key',
                ]
            },
            root_map={
                'validations': {
                    ('lock_key',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]{8,}$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'action_id':
                        (str,),
                    'workflow_id':
                        (str,),
                    'account_id':
                        (int,),
                    'lock_key':
                        (str,),
                },
                'attribute_map': {
                    'action_id': 'action_id',
                    'workflow_id': 'workflow_id',
                    'account_id': 'account_id',
                    'lock_key': 'lock_key',
                },
                'location_map': {
                    'action_id': 'path',
                    'workflow_id': 'path',
                    'account_id': 'query',
                    'lock_key': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_action_endpoint = _Endpoint(
            settings={
                'response_type': (GetActionResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/workflows/{workflow_id}/actions/{action_id}',
                'operation_id': 'get_action',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_id',
                    'action_id',
                    'account_id',
                    'lock_key',
                ],
                'required': [
                    'workflow_id',
                    'action_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'lock_key',
                ]
            },
            root_map={
                'validations': {
                    ('lock_key',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]{8,}$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_id':
                        (str,),
                    'action_id':
                        (str,),
                    'account_id':
                        (int,),
                    'lock_key':
                        (str,),
                },
                'attribute_map': {
                    'workflow_id': 'workflow_id',
                    'action_id': 'action_id',
                    'account_id': 'account_id',
                    'lock_key': 'lock_key',
                },
                'location_map': {
                    'workflow_id': 'path',
                    'action_id': 'path',
                    'account_id': 'query',
                    'lock_key': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.list_action_links_endpoint = _Endpoint(
            settings={
                'response_type': (LinksResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/workflows/{workflow_id}/actions/{action_id}/links',
                'operation_id': 'list_action_links',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'action_id',
                    'workflow_id',
                    'account_id',
                    'page',
                    'per_page',
                    'with_count',
                ],
                'required': [
                    'action_id',
                    'workflow_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'action_id':
                        (str,),
                    'workflow_id':
                        (str,),
                    'account_id':
                        (int,),
                    'page':
                        (int,),
                    'per_page':
                        (int,),
                    'with_count':
                        (bool,),
                },
                'attribute_map': {
                    'action_id': 'action_id',
                    'workflow_id': 'workflow_id',
                    'account_id': 'account_id',
                    'page': 'page',
                    'per_page': 'per_page',
                    'with_count': 'with_count',
                },
                'location_map': {
                    'action_id': 'path',
                    'workflow_id': 'path',
                    'account_id': 'query',
                    'page': 'query',
                    'per_page': 'query',
                    'with_count': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.list_actions_endpoint = _Endpoint(
            settings={
                'response_type': (ActionsResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/workflows/{workflow_id}/actions',
                'operation_id': 'list_actions',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_id',
                    'page',
                    'per_page',
                    'with_count',
                    'account_id',
                    'sort',
                ],
                'required': [
                    'workflow_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_id':
                        (str,),
                    'page':
                        (int,),
                    'per_page':
                        (int,),
                    'with_count':
                        (bool,),
                    'account_id':
                        (int,),
                    'sort':
                        (str,),
                },
                'attribute_map': {
                    'workflow_id': 'workflow_id',
                    'page': 'page',
                    'per_page': 'per_page',
                    'with_count': 'with_count',
                    'account_id': 'account_id',
                    'sort': 'sort',
                },
                'location_map': {
                    'workflow_id': 'path',
                    'page': 'query',
                    'per_page': 'query',
                    'with_count': 'query',
                    'account_id': 'query',
                    'sort': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.patch_action_endpoint = _Endpoint(
            settings={
                'response_type': (PatchActionResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/workflows/{workflow_id}/actions/{action_id}',
                'operation_id': 'patch_action',
                'http_method': 'PATCH',
                'servers': None,
            },
            params_map={
                'all': [
                    'action_id',
                    'workflow_id',
                    'patch_action',
                    'account_id',
                    'lock_key',
                ],
                'required': [
                    'action_id',
                    'workflow_id',
                    'patch_action',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'lock_key',
                ]
            },
            root_map={
                'validations': {
                    ('lock_key',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]{8,}$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'action_id':
                        (str,),
                    'workflow_id':
                        (str,),
                    'patch_action':
                        (PatchAction,),
                    'account_id':
                        (int,),
                    'lock_key':
                        (str,),
                },
                'attribute_map': {
                    'action_id': 'action_id',
                    'workflow_id': 'workflow_id',
                    'account_id': 'account_id',
                    'lock_key': 'lock_key',
                },
                'location_map': {
                    'action_id': 'path',
                    'workflow_id': 'path',
                    'patch_action': 'body',
                    'account_id': 'query',
                    'lock_key': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.render_action_endpoint = _Endpoint(
            settings={
                'response_type': (str,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/workflows/{workflow_id}/actions/{action_id}/render',
                'operation_id': 'render_action',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_id',
                    'action_id',
                    'account_id',
                    'lock_key',
                ],
                'required': [
                    'workflow_id',
                    'action_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'lock_key',
                ]
            },
            root_map={
                'validations': {
                    ('lock_key',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]{8,}$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_id':
                        (str,),
                    'action_id':
                        (str,),
                    'account_id':
                        (int,),
                    'lock_key':
                        (str,),
                },
                'attribute_map': {
                    'workflow_id': 'workflow_id',
                    'action_id': 'action_id',
                    'account_id': 'account_id',
                    'lock_key': 'lock_key',
                },
                'location_map': {
                    'workflow_id': 'path',
                    'action_id': 'path',
                    'account_id': 'query',
                    'lock_key': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'text/html',
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.send_test_action_endpoint = _Endpoint(
            settings={
                'response_type': (SendTestActionResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/workflows/{workflow_id}/actions/{action_id}/send-test',
                'operation_id': 'send_test_action',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_id',
                    'action_id',
                    'send_test_action',
                    'account_id',
                    'lock_key',
                ],
                'required': [
                    'workflow_id',
                    'action_id',
                    'send_test_action',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'lock_key',
                ]
            },
            root_map={
                'validations': {
                    ('lock_key',): {

                        'regex': {
                            'pattern': r'^[a-zA-Z0-9-_]{8,}$',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_id':
                        (str,),
                    'action_id':
                        (str,),
                    'send_test_action':
                        (SendTestAction,),
                    'account_id':
                        (int,),
                    'lock_key':
                        (str,),
                },
                'attribute_map': {
                    'workflow_id': 'workflow_id',
                    'action_id': 'action_id',
                    'account_id': 'account_id',
                    'lock_key': 'lock_key',
                },
                'location_map': {
                    'workflow_id': 'path',
                    'action_id': 'path',
                    'send_test_action': 'body',
                    'account_id': 'query',
                    'lock_key': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def create_action(
        self,
        workflow_id,
        action,
        **kwargs
    ):
        """Create an action  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_action(workflow_id, action, async_req=True)
        >>> result = thread.get()

        Args:
            workflow_id (str):
            action (Action):

        Keyword Args:
            account_id (int): [optional]
            lock_key (str): Locking key, preventing other users from modifying this workflow for a short period.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            CreateActionResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['workflow_id'] = \
            workflow_id
        kwargs['action'] = \
            action
        return self.create_action_endpoint.call_with_http_info(**kwargs)

    def delete_action(
        self,
        action_id,
        workflow_id,
        **kwargs
    ):
        """Delete an action  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_action(action_id, workflow_id, async_req=True)
        >>> result = thread.get()

        Args:
            action_id (str):
            workflow_id (str):

        Keyword Args:
            account_id (int): [optional]
            lock_key (str): Locking key, preventing other users from modifying this workflow for a short period.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            DeleteActionResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['action_id'] = \
            action_id
        kwargs['workflow_id'] = \
            workflow_id
        return self.delete_action_endpoint.call_with_http_info(**kwargs)

    def get_action(
        self,
        workflow_id,
        action_id,
        **kwargs
    ):
        """Get an action  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_action(workflow_id, action_id, async_req=True)
        >>> result = thread.get()

        Args:
            workflow_id (str):
            action_id (str):

        Keyword Args:
            account_id (int): [optional]
            lock_key (str): Locking key, preventing other users from modifying this workflow for a short period.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            GetActionResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['workflow_id'] = \
            workflow_id
        kwargs['action_id'] = \
            action_id
        return self.get_action_endpoint.call_with_http_info(**kwargs)

    def list_action_links(
        self,
        action_id,
        workflow_id,
        **kwargs
    ):
        """Show action links  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_action_links(action_id, workflow_id, async_req=True)
        >>> result = thread.get()

        Args:
            action_id (str):
            workflow_id (str):

        Keyword Args:
            account_id (int): [optional]
            page (int): [optional] if omitted the server will use the default value of 1
            per_page (int): [optional] if omitted the server will use the default value of 50
            with_count (bool): [optional] if omitted the server will use the default value of False
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            LinksResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['action_id'] = \
            action_id
        kwargs['workflow_id'] = \
            workflow_id
        return self.list_action_links_endpoint.call_with_http_info(**kwargs)

    def list_actions(
        self,
        workflow_id,
        **kwargs
    ):
        """List actions  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_actions(workflow_id, async_req=True)
        >>> result = thread.get()

        Args:
            workflow_id (str):

        Keyword Args:
            page (int): [optional] if omitted the server will use the default value of 1
            per_page (int): [optional] if omitted the server will use the default value of 50
            with_count (bool): [optional] if omitted the server will use the default value of False
            account_id (int): [optional]
            sort (str): Sort term and direction, using syntax `[-|+]term`.  Valid terms:   - `name`   - `created_on`. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ActionsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['workflow_id'] = \
            workflow_id
        return self.list_actions_endpoint.call_with_http_info(**kwargs)

    def patch_action(
        self,
        action_id,
        workflow_id,
        patch_action,
        **kwargs
    ):
        """Update an action  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.patch_action(action_id, workflow_id, patch_action, async_req=True)
        >>> result = thread.get()

        Args:
            action_id (str):
            workflow_id (str):
            patch_action (PatchAction):

        Keyword Args:
            account_id (int): [optional]
            lock_key (str): Locking key, preventing other users from modifying this workflow for a short period.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            PatchActionResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['action_id'] = \
            action_id
        kwargs['workflow_id'] = \
            workflow_id
        kwargs['patch_action'] = \
            patch_action
        return self.patch_action_endpoint.call_with_http_info(**kwargs)

    def render_action(
        self,
        workflow_id,
        action_id,
        **kwargs
    ):
        """Render an action  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.render_action(workflow_id, action_id, async_req=True)
        >>> result = thread.get()

        Args:
            workflow_id (str):
            action_id (str):

        Keyword Args:
            account_id (int): [optional]
            lock_key (str): Locking key, preventing other users from modifying this workflow for a short period.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            str
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['workflow_id'] = \
            workflow_id
        kwargs['action_id'] = \
            action_id
        return self.render_action_endpoint.call_with_http_info(**kwargs)

    def send_test_action(
        self,
        workflow_id,
        action_id,
        send_test_action,
        **kwargs
    ):
        """Send a test of an action  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.send_test_action(workflow_id, action_id, send_test_action, async_req=True)
        >>> result = thread.get()

        Args:
            workflow_id (str):
            action_id (str):
            send_test_action (SendTestAction):

        Keyword Args:
            account_id (int): [optional]
            lock_key (str): Locking key, preventing other users from modifying this workflow for a short period.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            SendTestActionResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['workflow_id'] = \
            workflow_id
        kwargs['action_id'] = \
            action_id
        kwargs['send_test_action'] = \
            send_test_action
        return self.send_test_action_endpoint.call_with_http_info(**kwargs)

