"""
    Cakemail API

    The Cakemail API exposes multiple APIs including Authentication, Marketing, Contact, Transactional, Analytic, Content, Account and Partner.  # noqa: E501

    The version of the OpenAPI document: 1.9.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from cakemail_openapi.api_client import ApiClient, Endpoint as _Endpoint
from cakemail_openapi.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from cakemail_openapi.model.action_logs_response import ActionLogsResponse
from cakemail_openapi.model.campaign_logs_response import CampaignLogsResponse
from cakemail_openapi.model.email_logs_response import EmailLogsResponse
from cakemail_openapi.model.http_bad_request_error import HTTPBadRequestError
from cakemail_openapi.model.http_validation_error import HTTPValidationError
from cakemail_openapi.model.list_logs_response import ListLogsResponse


class LogApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.get_action_logs_endpoint = _Endpoint(
            settings={
                'response_type': (ActionLogsResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/logs/workflows/{workflow_id}/actions/{action_id}',
                'operation_id': 'get_action_logs',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'workflow_id',
                    'action_id',
                    'account_id',
                    'start_time',
                    'end_time',
                    'page',
                    'per_page',
                    'with_count',
                    'filter',
                    'sort',
                ],
                'required': [
                    'workflow_id',
                    'action_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'start_time',
                    'end_time',
                    'page',
                    'per_page',
                    'sort',
                ]
            },
            root_map={
                'validations': {
                    ('start_time',): {

                        'inclusive_maximum': 2147483647,
                        'inclusive_minimum': 1,
                    },
                    ('end_time',): {

                        'inclusive_maximum': 2147483647,
                        'inclusive_minimum': 1,
                    },
                    ('page',): {

                        'inclusive_minimum': 1,
                    },
                    ('per_page',): {

                        'inclusive_minimum': 1,
                    },
                    ('sort',): {

                        'regex': {
                            'pattern': r'[-|+]?.*',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'workflow_id':
                        (str,),
                    'action_id':
                        (str,),
                    'account_id':
                        (int,),
                    'start_time':
                        (int,),
                    'end_time':
                        (int,),
                    'page':
                        (int,),
                    'per_page':
                        (int,),
                    'with_count':
                        (bool,),
                    'filter':
                        (str,),
                    'sort':
                        (str,),
                },
                'attribute_map': {
                    'workflow_id': 'workflow_id',
                    'action_id': 'action_id',
                    'account_id': 'account_id',
                    'start_time': 'start_time',
                    'end_time': 'end_time',
                    'page': 'page',
                    'per_page': 'per_page',
                    'with_count': 'with_count',
                    'filter': 'filter',
                    'sort': 'sort',
                },
                'location_map': {
                    'workflow_id': 'path',
                    'action_id': 'path',
                    'account_id': 'query',
                    'start_time': 'query',
                    'end_time': 'query',
                    'page': 'query',
                    'per_page': 'query',
                    'with_count': 'query',
                    'filter': 'query',
                    'sort': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_campaign_logs_endpoint = _Endpoint(
            settings={
                'response_type': (CampaignLogsResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/logs/campaigns/{campaign_id}',
                'operation_id': 'get_campaign_logs',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'campaign_id',
                    'account_id',
                    'start_time',
                    'end_time',
                    'page',
                    'per_page',
                    'with_count',
                    'filter',
                    'sort',
                ],
                'required': [
                    'campaign_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'campaign_id',
                    'start_time',
                    'end_time',
                    'page',
                    'per_page',
                    'sort',
                ]
            },
            root_map={
                'validations': {
                    ('campaign_id',): {

                        'inclusive_minimum': 1,
                    },
                    ('start_time',): {

                        'inclusive_maximum': 2147483647,
                        'inclusive_minimum': 1,
                    },
                    ('end_time',): {

                        'inclusive_maximum': 2147483647,
                        'inclusive_minimum': 1,
                    },
                    ('page',): {

                        'inclusive_minimum': 1,
                    },
                    ('per_page',): {

                        'inclusive_minimum': 1,
                    },
                    ('sort',): {

                        'regex': {
                            'pattern': r'[-|+]?.*',  # noqa: E501
                        },
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'campaign_id':
                        (int,),
                    'account_id':
                        (int,),
                    'start_time':
                        (int,),
                    'end_time':
                        (int,),
                    'page':
                        (int,),
                    'per_page':
                        (int,),
                    'with_count':
                        (bool,),
                    'filter':
                        (str,),
                    'sort':
                        (str,),
                },
                'attribute_map': {
                    'campaign_id': 'campaign_id',
                    'account_id': 'account_id',
                    'start_time': 'start_time',
                    'end_time': 'end_time',
                    'page': 'page',
                    'per_page': 'per_page',
                    'with_count': 'with_count',
                    'filter': 'filter',
                    'sort': 'sort',
                },
                'location_map': {
                    'campaign_id': 'path',
                    'account_id': 'query',
                    'start_time': 'query',
                    'end_time': 'query',
                    'page': 'query',
                    'per_page': 'query',
                    'with_count': 'query',
                    'filter': 'query',
                    'sort': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_email_logs_endpoint = _Endpoint(
            settings={
                'response_type': (EmailLogsResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/logs/emails',
                'operation_id': 'get_email_logs',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'log_type',
                    'account_id',
                    'start_time',
                    'end_time',
                    'page',
                    'per_page',
                    'with_count',
                    'filter',
                ],
                'required': [
                    'log_type',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'start_time',
                    'end_time',
                    'page',
                    'per_page',
                ]
            },
            root_map={
                'validations': {
                    ('start_time',): {

                        'inclusive_maximum': 2147483647,
                        'inclusive_minimum': 1,
                    },
                    ('end_time',): {

                        'inclusive_maximum': 2147483647,
                        'inclusive_minimum': 1,
                    },
                    ('page',): {

                        'inclusive_minimum': 1,
                    },
                    ('per_page',): {

                        'inclusive_minimum': 1,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'log_type':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'account_id':
                        (int,),
                    'start_time':
                        (int,),
                    'end_time':
                        (int,),
                    'page':
                        (int,),
                    'per_page':
                        (int,),
                    'with_count':
                        (bool,),
                    'filter':
                        (str,),
                },
                'attribute_map': {
                    'log_type': 'log_type',
                    'account_id': 'account_id',
                    'start_time': 'start_time',
                    'end_time': 'end_time',
                    'page': 'page',
                    'per_page': 'per_page',
                    'with_count': 'with_count',
                    'filter': 'filter',
                },
                'location_map': {
                    'log_type': 'query',
                    'account_id': 'query',
                    'start_time': 'query',
                    'end_time': 'query',
                    'page': 'query',
                    'per_page': 'query',
                    'with_count': 'query',
                    'filter': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_list_logs_endpoint = _Endpoint(
            settings={
                'response_type': (ListLogsResponse,),
                'auth': [
                    'OAuth2PasswordBearer'
                ],
                'endpoint_path': '/logs/lists/{list_id}',
                'operation_id': 'get_list_logs',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'list_id',
                    'account_id',
                    'start_time',
                    'end_time',
                    'page',
                    'per_page',
                    'with_count',
                    'filter',
                ],
                'required': [
                    'list_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'list_id',
                    'start_time',
                    'end_time',
                    'page',
                    'per_page',
                ]
            },
            root_map={
                'validations': {
                    ('list_id',): {

                        'inclusive_minimum': 1,
                    },
                    ('start_time',): {

                        'inclusive_maximum': 2147483647,
                        'inclusive_minimum': 1,
                    },
                    ('end_time',): {

                        'inclusive_maximum': 2147483647,
                        'inclusive_minimum': 1,
                    },
                    ('page',): {

                        'inclusive_minimum': 1,
                    },
                    ('per_page',): {

                        'inclusive_minimum': 1,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'list_id':
                        (int,),
                    'account_id':
                        (int,),
                    'start_time':
                        (int,),
                    'end_time':
                        (int,),
                    'page':
                        (int,),
                    'per_page':
                        (int,),
                    'with_count':
                        (bool,),
                    'filter':
                        (str,),
                },
                'attribute_map': {
                    'list_id': 'list_id',
                    'account_id': 'account_id',
                    'start_time': 'start_time',
                    'end_time': 'end_time',
                    'page': 'page',
                    'per_page': 'per_page',
                    'with_count': 'with_count',
                    'filter': 'filter',
                },
                'location_map': {
                    'list_id': 'path',
                    'account_id': 'query',
                    'start_time': 'query',
                    'end_time': 'query',
                    'page': 'query',
                    'per_page': 'query',
                    'with_count': 'query',
                    'filter': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def get_action_logs(
        self,
        workflow_id,
        action_id,
        **kwargs
    ):
        """Show action logs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_action_logs(workflow_id, action_id, async_req=True)
        >>> result = thread.get()

        Args:
            workflow_id (str):
            action_id (str):

        Keyword Args:
            account_id (int): [optional]
            start_time (int): [optional]
            end_time (int): [optional]
            page (int): [optional] if omitted the server will use the default value of 1
            per_page (int): [optional] if omitted the server will use the default value of 50
            with_count (bool): [optional] if omitted the server will use the default value of False
            filter (str): Valid Terms:   - `additional_info`   - `link_id`   - `contact_id`   - `email`   - `log_id`   - `track_id`   - `type`  Valid Operators:   - `==`  Query separator:   - `;`. [optional]
            sort (str): Sort term and direction, using syntax `[-|+]term`.  Valid terms:   - `time`   - `log_id`. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ActionLogsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['workflow_id'] = \
            workflow_id
        kwargs['action_id'] = \
            action_id
        return self.get_action_logs_endpoint.call_with_http_info(**kwargs)

    def get_campaign_logs(
        self,
        campaign_id,
        **kwargs
    ):
        """Show campaign logs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_campaign_logs(campaign_id, async_req=True)
        >>> result = thread.get()

        Args:
            campaign_id (int):

        Keyword Args:
            account_id (int): [optional]
            start_time (int): [optional]
            end_time (int): [optional]
            page (int): [optional] if omitted the server will use the default value of 1
            per_page (int): [optional] if omitted the server will use the default value of 50
            with_count (bool): [optional] if omitted the server will use the default value of False
            filter (str): Valid Terms:   - `additional_info`   - `link_id`   - `contact_id`   - `email`   - `uniques`   - `log_id`   - `totals`   - `type`  Valid Operators:   - `==`  Query separator:   - `;`. [optional]
            sort (str): Sort term and direction, using syntax `[-|+]term`.  Valid terms:   - `time`   - `log_id`. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            CampaignLogsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['campaign_id'] = \
            campaign_id
        return self.get_campaign_logs_endpoint.call_with_http_info(**kwargs)

    def get_email_logs(
        self,
        log_type,
        **kwargs
    ):
        """Show transactional email logs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_email_logs(log_type, async_req=True)
        >>> result = thread.get()

        Args:
            log_type (bool, date, datetime, dict, float, int, list, str, none_type):

        Keyword Args:
            account_id (int): [optional]
            start_time (int): [optional]
            end_time (int): [optional]
            page (int): [optional] if omitted the server will use the default value of 1
            per_page (int): [optional] if omitted the server will use the default value of 50
            with_count (bool): [optional] if omitted the server will use the default value of False
            filter (str): Valid Terms:   - `group_id`   - `email`  Valid Operators:   - `==`  Query separator:   - `;`. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            EmailLogsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['log_type'] = \
            log_type
        return self.get_email_logs_endpoint.call_with_http_info(**kwargs)

    def get_list_logs(
        self,
        list_id,
        **kwargs
    ):
        """Show list logs  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_list_logs(list_id, async_req=True)
        >>> result = thread.get()

        Args:
            list_id (int):

        Keyword Args:
            account_id (int): [optional]
            start_time (int): [optional]
            end_time (int): [optional]
            page (int): [optional] if omitted the server will use the default value of 1
            per_page (int): [optional] if omitted the server will use the default value of 50
            with_count (bool): [optional] if omitted the server will use the default value of False
            filter (str): Valid Terms:   - `additional_info`   - `contact_id`   - `email`   - `uniques`   - `track_id`   - `log_id`   - `start_id`   - `end_id`   - `totals`   - `type`  Valid Operators:   - `==`  Query separator:   - `;`. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ListLogsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['list_id'] = \
            list_id
        return self.get_list_logs_endpoint.call_with_http_info(**kwargs)

